diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/unix_dir.p v15.6301-amd64/pop/src/unix_dir.p
--- v15.63/pop/src/unix_dir.p	2007-10-01 09:26:05.000000000 -0400
+++ v15.6301-amd64/pop/src/unix_dir.p	2008-06-05 09:22:05.000000000 -0400
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 2007. All rights reserved. ----------
+/* --- Copyright University of Sussex 1997. All rights reserved. ----------
  > File:			C.unix/src/unix_dir.p
  > Purpose:
  > Author:			John Gibson et al (see revisions)
@@ -66,8 +66,8 @@
 
 define Open_stream(dirname) -> _fd;
 	lvars dirname, _fd;
-	if _neg($-Sys$-Io$-Opencreate(dirname, dirname, O_RDONLY, 0) ->> _fd)
-	then
+	if ($-Sys$-Io$-Opencreate(dirname, dirname, O_RDONLY, 0) ->> _fd)
+             _gr _2147483647 then
 		_NULL -> _fd
 	endif
 enddefine;
@@ -84,7 +84,7 @@
 		_extern[NI] read(_fd, _dir_entry@(w->b), ##DIR_END_BYTE) -> _n;
 		unless _n == ##DIR_END_BYTE then
 			if _nonzero(_n) then
-				if _neg(_n) then
+				if (_n) _gr _2147483647 then
 					Syserr_mishap(0, 'ERROR READING ..')
 				else
 					mishap(0, 'ERROR READING .. (premature end of file)')
@@ -188,8 +188,6 @@
 #_ELSE
 	;;; not for linux
 
-/* old version, replaced by new version above for linux */
-
 define lconstant Get_curr_dir();
 	lvars	path, _dir_entry, _dotdev, _dotdev2, _dotino,
 			_rootdev, _rootdev2, _rootino, _dirp;
@@ -219,8 +217,10 @@
 		if (Open_stream('..') ->> _dirp) == _NULL then
 			mishap(0, 'CAN\'T OPEN DIRECTORY ..')
 		endif;
+;;;                _extern printf('_dirp = %ld\n', _dirp) -> _;
+;;;                _extern fflush(_0) -> _;
 		_extern[NI] stat(_dotdotdir, _statb) -> ;
-		if _neg(_extern[NI] chdir(_dotdotdir)) then
+		if (_extern[NI] chdir(_dotdotdir)) _gr _2147483647 then
 			mishap(0, 'CAN\'T CHANGE DIRECTORY TO ..');
 		endif;
 
@@ -230,6 +230,8 @@
 				if (Read_entry(_dirp) ->> _dir_entry) == _NULL then
 					mishap(0, PEOF_ms)
 				endif;
+;;;                                _extern printf('_dirp = %ld\n', _dirp) -> _;
+;;;                                _extern fflush(_0) -> _;
 				quitif(_dir_entry!DIR_INO == _dotino)
 			endrepeat
 		else
@@ -237,6 +239,8 @@
 				if (Read_entry(_dirp) ->> _dir_entry) == _NULL then
 					mishap(0, PEOF_ms)
 				endif;
+;;;                 _extern printf('_dirp = %ld\n', _dirp) -> _;
+;;;                _extern fflush(_0) -> _;
 				_extern[NI] stat(_dir_entry@DIR_NAME, _statb) ->;
 				quitif( DEV_T_==_VARS(_statb, ST_DEV, _dotdev, _dotdev2)
 						and _statb!ST_INO == _dotino)
@@ -251,12 +255,16 @@
 			endprocedure(_dir_entry),
 			deststring(path) ->
 		|#) -> path;
+;;;                _extern printf('3 _dirp = %ld\n', _dirp) -> _;
+;;;                _extern fflush(_0) -> _;
 		Close_stream(_dirp)
 	endrepeat;
 
 	;;; change back to current directory!!!
 	_extern[NI] chdir(Encode_sys(path,_nbuf)) -> ;
 
+;;;        _extern printf('chdir(%s)\n', Encode_sys(path,_nbuf))-> _;
+;;;        _extern fflush(_0) -> _;
 	Clawback(path)
 enddefine;
 
@@ -275,7 +283,7 @@
 	lstackmem stackbuff _nbuf;
 	returnif((sysfileok(new_dir) ->> new_dir) = current);
 	if new_dir = nullstring then systranslate('HOME') -> new_dir endif;
-	if _neg(_extern[NI] chdir(Encode_sys(new_dir,_nbuf))) then
+	if (_extern[NI] chdir(Encode_sys(new_dir,_nbuf))) _gr _2147483647 then
 		Syserr_mishap(new_dir, 1, 'CAN\'T CHANGE DIRECTORY')
 	endif;
 	false -> current
Only in v15.63/pop/src: unix_dir.p-1999-05-20
Only in v15.6301-amd64/pop/src: unix_dir.p.adm64.orig
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/unixdefs.ph v15.6301-amd64/pop/src/unixdefs.ph
--- v15.63/pop/src/unixdefs.ph	2004-12-31 07:01:25.000000000 -0500
+++ v15.6301-amd64/pop/src/unixdefs.ph	2009-12-24 15:31:05.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 2004. All rights reserved. ----------
+/* --- Copyright University of Sussex 1999. All rights reserved. ----------
  > File:			C.unix/src/unixdefs.ph
  > Purpose:
  > Author:			John Gibson (see revisions)
@@ -50,9 +50,9 @@
 
 deftype
 	dev_t	= double,
-	ino_t	= int,
+	ino_t	= long,
 	mode_t	= int,
-	nlink_t	= int,
+	nlink_t	= long,
 	time_t	= -long,
 	uid_t	= int,
 	gid_t	= uid_t;
@@ -175,14 +175,13 @@
 
 struct STATB
   {	dev_t	ST_DEV;
-	short	ST_PAD1;	/* reserved for network id */
 	ino_t	ST_INO;
-	mode_t	ST_MODE;
 	nlink_t ST_NLINK;
+        mode_t  ST_MODE;
 	uid_t 	ST_UID;
 	gid_t 	ST_GID;
+        int     ST_PAD2;
 	dev_t	ST_RDEV;
-	short	ST_PAD2;
 	off_t	ST_SIZE;
 	long	ST_BLKSIZE;
 	blkcnt_t ST_BLOCKS;
@@ -192,7 +191,7 @@
 	long	ST_MTIME_X;
 	time_t	ST_CTIME;
 	long	ST_CTIME_X;
-	long	ST_PAD4[2];	/* expansion area */
+	long	ST_PAD4[3];	/* expansion area */
   };
 
 #_ELSEIF DEF BERKELEY and not(DEF IRIX)
@@ -494,7 +493,7 @@
 ;;; --- TIMES/TIMERS -------------------------------------------------------
 
 struct TMS
-  { int	TMS_UTIME,
+  { long	TMS_UTIME,
 		TMS_STIME,
 		TMS_CUTIME,
 		TMS_CSTIME;
@@ -549,7 +548,7 @@
 
 ;;; -- MISCELLANEOUS ------------------------------------------------------
 
-#_IF DEF HPUX or DEF IRIX or DEF SYSTEM_V
+#_IF true /* DEF HPUX or DEF IRIX or DEF SYSTEM_V */
 
 ;;; strings returned by tgetstr() have terminfo-style escapes
 lconstant macro USE_TERMINFO = true;
@@ -640,28 +639,6 @@
 
 
 /* --- Revision History ---------------------------------------------------
---- Aaron Sloman, Dec 31 2004
-	Added the documentation below for changes to errno.
-		
---- Aaron Sloman and Waldek Hebisch 29 Jun 2003
-	The use of 'errno' which has been deprecated for some time is no longer
-	supported. So the old use is simulated using these two procedures defined
-	in $popexternlib/c_core.c (thanks to Waldek Hebisch):
-		int get_libc_errno(void)
-		int set_libc_errno(int x)
-	The are accessed via an active variable defined in $popsrc/errors.p
-
-		define active DO_ERRNO_VAL();
-
-		define updaterof active DO_ERRNO_VAL(_x);
-
-	This macro definition is no longer used
-		lconstant macro _ERRNO = [_extern errno:data!(int)];
-
-	Instead it is defined thus to invoke the active variable or its updater
-
-		lconstant macro _ERRNO = [DO_ERRNO_VAL];
-
 --- John Gibson, Apr  9 1999
 		Replaced test ALPHA_LINUX or (X86_LINUX and LIN*UX_GLI*BC) with
 		DEFV LINUX >= 2.0
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/vec_generic.p v15.6301-amd64/pop/src/vec_generic.p
--- v15.63/pop/src/vec_generic.p	1997-02-12 12:29:00.000000000 -0500
+++ v15.6301-amd64/pop/src/vec_generic.p	2009-12-30 14:59:15.000000000 -0500
@@ -44,8 +44,26 @@
 enddefine;
 
 define Byte_hash(_cptr, _len);
+#_IF false
 	lvars _len, _cptr;
 	CHAR_HASH(b)
+#_ELSE
+    lvars _res = _len;
+    while _len _sgr _3 do
+        _cptr!(i) _add _res -> _res;
+        _len _add _-4 -> _len;
+        _cptr _add _4 -> _cptr;
+    endwhile;
+    if _len == _3 then
+        (_cptr!(i) _bimask _16:FFFFFF) _add _res -> _res;
+    elseif _len == _2 then
+        _cptr!(s) _add _res -> _res;
+    elseif _len == _1 then
+        _cptr!(b)[_0] _add _res -> _res;
+    endif;
+   ;;; Mix bits
+   _shift(_res _bimask _16:FFFE0000, _-17) _bixor _res
+#_ENDIF
 enddefine;
 
 define Short_hash(_cptr, _len);
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/vm_conspdr.p v15.6301-amd64/pop/src/vm_conspdr.p
--- v15.63/pop/src/vm_conspdr.p	2005-02-12 15:05:49.000000000 -0500
+++ v15.6301-amd64/pop/src/vm_conspdr.p	2009-12-27 00:36:41.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 2005. All rights reserved. ----------
+/* --- Copyright University of Sussex 2003. All rights reserved. ----------
  > File:            C.all/src/vm_conspdr.p
  > Purpose:
  > Author:          John Gibson, Mar 11 1988 (see revisions)
@@ -387,6 +387,9 @@
 	enduntil;
 	instr!INST_OP -> _op;
 	if _op == I_NOT then
+                ;;; Check for double negation, we could do better but
+                ;;; this is very rare.
+                returnif(is_not)(false);
 		Optimise_clist_tl(next_clist, true)
 	else
 		if IS_UNOPT_JUMP(_op) ->> _op then
@@ -1176,11 +1179,10 @@
 	endif;
 
 	Incr_lab_refcount(asm_exit_lab);
-	;;; check proposed by Waldek Hebisch
-	if _Nframewords _gr _16:FF then
-		mishap(0, 'PROCEDURE STACK FRAME TOO LARGE (too many lvars?)');
-	endif;
 
+        if _Nframewords _gr _:MAX_STACK_FRAME_SIZE then
+          mishap(0, 'PROCEDURE STACK FRAME TOO LARGE (too many lvars?)');
+        endif;
 	;;; first instruction creates stack frame on entry
 	Cons_inst(I_CREATE_SF, 1) :: codelist -> codelist;
 
@@ -1235,8 +1237,6 @@
 
 
 /* --- Revision History ---------------------------------------------------
---- Aaron Sloman, Feb 12 2005
-		Check for stack frame limit exceeded suggested by Waldek Hebisch
 --- David Young, Oct  8 2003
         Fixed bug in Optimise_conditions which caused a sequence of I_NOTs
         followed by an I_GOTO to be incorrectly ignored. This was
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/x/Xpm/xpmP.h v15.6301-amd64/pop/x/Xpm/xpmP.h
--- v15.63/pop/x/Xpm/xpmP.h	1996-03-04 06:07:41.000000000 -0500
+++ v15.6301-amd64/pop/x/Xpm/xpmP.h	2005-03-11 05:30:40.000000000 -0500
@@ -15,6 +15,7 @@
 #include "sys$library:stdio.h"
 #else
 #include <stdio.h>
+#include <stdlib.h>
 /* stdio.h doesn't declare popen on a Sequent DYNIX OS */
 #ifdef sequent
 extern FILE *popen();
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/x/src/xt_error.p v15.6301-amd64/pop/x/src/xt_error.p
--- v15.63/pop/x/src/xt_error.p	2007-01-06 18:22:53.000000000 -0500
+++ v15.6301-amd64/pop/x/src/xt_error.p	1996-02-06 09:52:14.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 2007. All rights reserved. ----------
+/* --- Copyright University of Sussex 1996. All rights reserved. ----------
  > File:            C.x/x/src/xt_error.p
  > Purpose:         X Toolkit - error handlers
  > Author:          Roger Evans, Jul  5 1990 (see revisions)
@@ -66,33 +66,13 @@
 error stream. Not for public use -- called from XtPoplog.c
 */
 
-;;; Modified this to cope with lesstif warning messages.
 define Xpt_sys_pr_message(exptr);
 	lvars exptr, string;
 	exacc_ntstring(exptr) -> string;
 	if string == termin then
 		cucharerr(`\n`)
 	else
-		;;; Inserted by A.S. because of Lesstif problem
-		if issubstring('XtRemoveGrab asked', string)
-		then
-			;;; A.S. 6 Jan 2007 Print warnings ONLY if pop_debugging
-			;;; has value 'lesstif'. Even then print shortened message.
-			if pop_debugging = 'lesstif' then
-				'Lesstif removegrab warning' -> string;
-				sys_pr_message(0, {^string ^nullstring 16:01}, nullstring, `W`);
-				;;; sysobey('echo Lesstif removegrab warning');
-			endif;
-		else
-			;;; Not sure what to do with blank strings. They have
-			;;; caused problems in already closed windows. Should there be a test here?
-
-			;;; Print the warning. It's not the Lesstif one.
-			;;; AS. 6 Jan 2007. Fixed incorrect arg: was false now nullstring.
-			;;; sys_pr_message(0, {^string ^nullstring 16:01}, false, `W`);
-			sys_pr_message(0, {^string ^nullstring 16:01}, nullstring, `W`);
-			
-		endif;
+		sys_pr_message(0, {^string ^nullstring 16:01}, false, `W`)
 	endif
 enddefine;
 
@@ -103,17 +83,6 @@
 
 
 /* --- Revision History ---------------------------------------------------
---- Aaron Sloman, Jan  6 2007
-	Altered Xpt_sys_pr_message(exptr);  because of spurious warnings from
-	Lesstif when quitting windows.
-	;;; WARNING - xtw: X TOOLKIT WARNING (xtRemoveGrab: grabError -- XtRemoveGrab asked to remove a widget not on the list)
-
-	If pop_debugging = 'lesstif' then a shortened warning is printed.
-	If pop_debugging has any other value no warning is printed.
-	Other strings are printed as normal. For details see
-	http://www.cs.bham.ac.uk/research/projects/poplog/bugfixes/BUGREPORTS
-	(Search for Lesstif).
-		
 --- John Gibson, Feb  6 1996
 		Uses sys_pr_message instead of sys*prmessage
 --- Robert John Duncan, Feb  1 1995
Only in v15.6301-amd64/pop/x/src: xt_error.p-32-bit-poplog
Only in v15.63/pop/x/src: xt_error.p.orig
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/x/ui/lib/pop_ui_logo.p v15.6301-amd64/pop/x/ui/lib/pop_ui_logo.p
--- v15.63/pop/x/ui/lib/pop_ui_logo.p	1996-07-18 04:36:09.000000000 -0400
+++ v15.6301-amd64/pop/x/ui/lib/pop_ui_logo.p	2009-12-24 15:29:59.000000000 -0500
@@ -58,7 +58,7 @@
 	POPUIBITMAPS  dir_>< 'poplog_64.xbm', ;;; filename of xbm
 
 	sprintf(pop_internal_version / 10000.0, 'Sussex Poplog Version %p'),
-	'   Copyright \(169) 1982-1996, The University of Sussex   ',
+	'   Copyright \(169) 1982-2005, The University of Sussex   ',
 	'All Rights Reserved.',
 	'',
 	popmemused div 256 sys_>< ' Kilobytes used, ' sys_><
@@ -66,7 +66,12 @@
 	'    (editing ' sys_>< len sys_>< ' file',
 	if len ==  1 then sys_>< ')    ' else sys_>< 's)    ' endif,
 	'',
-	'Marketed under licence by:', 'Integral Solutions Ltd.',
+	'Poplog is free sftware, see:',
+        'http://www.cs.bham.ac.uk/research/poplog/freepoplog.html',
+        'and ftp://ftp.cs.bham.ac.uk/pub/dist/poplog/',
+        '',
+        'Previously marketed by:',
+        'Integral Solutions Ltd.',
 	'Berk House, Basing View',
 	'Basingstoke, Hants.',
 	'RG21 4RG, UK',
@@ -74,8 +79,6 @@
 	'Tel: +44 (0)1256 55899',
 	'Fax: +44 (0)1256 63467',
 	'',
-	'Email: isl@isl.co.uk',
-	'URL: http://www.isl.co.uk',
 	''
 	%]
 enddefine;
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/x/ved/src/xvedkey.p v15.6301-amd64/pop/x/ved/src/xvedkey.p
--- v15.63/pop/x/ved/src/xvedkey.p	1999-01-30 19:33:40.000000000 -0500
+++ v15.6301-amd64/pop/x/ved/src/xvedkey.p	2005-03-11 05:30:40.000000000 -0500
@@ -69,7 +69,8 @@
 	;;; DEFAULT - process the key and see if we can make some sense from it.
 
 	;;; ignore modifier keys and KeyRelease events.
-	returnif(keysym fi_< 0 or IsModifierKey(keysym));
+;;;        printf(keysym, 'keysym = %p\n') ;
+	returnif((keysym fi_< 0) or (536870911 < keysym) or IsModifierKey(keysym));
 
 	;;; test for keypad state
 	if xvedkeypadon then
